Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 706)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 708)
@@ -619,5 +619,4 @@
 	}
 
-	
 	// adjust stats and reset queue one final time
 	mExpectedCost = realExpectedCost;
@@ -627,5 +626,4 @@
 	UpdateActiveViewCells(activeViewCells);
 
-	
 	// refine view cells and reset costs
 	if (mRefineViewCells)
@@ -633,4 +631,5 @@
 	else
 		ResetMergeQueue();
+
 
 	// create a root node if the merge was not done till root level,
@@ -653,5 +652,5 @@
 		mRoot = activeViewCells[0];
 	}
-
+	
 	//-- empty merge queue just in case
 	while (!mMergeQueue.empty())
@@ -675,5 +674,5 @@
 	// assign colors for the view cells so that at least one is always consistent
 	AssignRandomColors();
-	
+
 	//TODO: should return sample contributions?
 	return mergeStats.merged;
@@ -1686,4 +1685,5 @@
 	
 	tqueue.push(mRoot);
+	
 	mRoot->SetColor(RandomColor(0.3f, 1.0f));
 	
@@ -1718,5 +1718,7 @@
 
 				if (maxViewCell)
+				{
 					maxViewCell->SetColor(vc->GetColor());
+				}
 				
 				tqueue.push(v);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 697)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.cpp	(revision 708)
@@ -3168,6 +3168,8 @@
 			ViewCell *viewCell;
 			
-			viewCell = mViewCellsTree->GetActiveViewCell(leaf->GetViewCell());
-			//viewCell = leaf->GetViewCell();
+			if (0)
+				viewCell = mViewCellsTree->GetActiveViewCell(leaf->GetViewCell());
+			else
+				viewCell = leaf->GetViewCell();
 
 			if (!viewCell->Mailed())
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 697)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.cpp	(revision 708)
@@ -1321,30 +1321,30 @@
 	RegisterOption("ViewCells.Visualization.colorCode",
 					optString,
-					"view_cells_visualization_color_code",
+					"view_cells_visualization_color_code=",
 					"PVS");
 
 	RegisterOption("ViewCells.Visualization.clipPlanePos",
 					optFloat,
-					"view_cells_visualization_clip_plane_pos",
+					"view_cells_visualization_clip_plane_pos=",
 					"0.35");
 	
 	RegisterOption("ViewCells.Visualization.exportGeometry",
 					optBool,
-					"view_cells_visualization_export_geometry",
+					"view_cells_visualization_export_geometry=",
 					"false");
 
 	RegisterOption("ViewCells.Visualization.exportRays",
 					optBool,
-					"view_cells_visualization_export_rays",
+					"view_cells_visualization_export_rays=",
 					"false");
 
 	RegisterOption("ViewCells.pruneEmptyViewCells",
 					optBool,
-					"view_cells_prune_empty_view_cells",
+					"view_cells_prune_empty=",
 					"false");
 
 	RegisterOption("ViewCells.processOnlyValidViewCells",
 					optBool,
-					"view_cells_process_only_valid_view_cells",
+					"view_cells_process_only_valid_view_cells=",
 					"false");
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 707)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsManager.cpp	(revision 708)
@@ -1223,5 +1223,5 @@
 		ViewCell *viewcell = *it;
 
-		if (viewcell->GetValid())// && mSampleEmptyViewCells) // HACK
+		if (viewcell->GetValid())
 		{
 			// HACK
@@ -3164,7 +3164,10 @@
 
 	// check if new view cells turned invalid
+	Debug << "setting validity, min: " << mMinPvsSize << " max: " << mMaxPvsSize << endl;
+	cout << "setting validity, min: " << mMinPvsSize << " max: " << mMaxPvsSize << endl;
 	SetValidity(mMinPvsSize, mMaxPvsSize); 
 	// update valid view space according to valid view cells
-	mVspBspTree->ValidateTree();
+	if (0)
+		mVspBspTree->ValidateTree();
 
 	// has to be recomputed
@@ -3183,7 +3186,9 @@
 	}
 
+	
 	//-- merge the individual view cells
 	MergeViewCells(postProcessRays, objects);
 	
+
 	// only for testing
 	TestSubdivision();
@@ -3763,6 +3768,5 @@
 				{
 					exporter->ExportPolygons(back.GetPolys());
-				}
-			
+				}			
 			}
 		}
@@ -4053,4 +4057,5 @@
 		vector<BspLeaf *> leaves;
 		mVspBspTree->CollectLeaves(leaves);
+	
 		mVspBspTree->CollectMergeCandidates(leaves, candidates);
 	}